package com.blamejared.compat.botania.lexicon;

import crafttweaker.api.item.IIngredient;
import com.blamejared.mtlib.helpers.LogHelper;
import vazkii.botania.api.lexicon.LexiconEntry;
import crafttweaker.CraftTweakerAPI;
import vazkii.botania.api.lexicon.LexiconRecipeMappings;
import com.blamejared.mtlib.helpers.InputHelper;
import com.blamejared.compat.botania.BotaniaHelper;
import crafttweaker.api.item.IItemStack;
import crafttweaker.IAction;

public class AddRecipeMapping implements IAction
{
    private IItemStack stack;
    private String entry;
    private int page;
    
    public AddRecipeMapping(final IItemStack stack, final String entry, final int page) {
        this.stack = stack;
        this.entry = entry;
        this.page = page;
    }
    
    public void apply() {
        final LexiconEntry lexiconentry = BotaniaHelper.findEntry(this.entry);
        if (LexiconRecipeMappings.getDataForStack(InputHelper.toStack(this.stack)) != null) {
            CraftTweakerAPI.getLogger().logError("There is already a recipe mapping for " + this.stack);
            return;
        }
        if (lexiconentry == null) {
            CraftTweakerAPI.getLogger().logError("Cannot find lexicon entry " + this.entry);
            return;
        }
        if (lexiconentry.pages.size() < this.page) {
            CraftTweakerAPI.getLogger().logError("Not enough pages in " + this.entry);
            return;
        }
        LexiconRecipeMappings.map(InputHelper.toStack(this.stack), lexiconentry, this.page);
    }
    
    public String describe() {
        return "Adding Lexicon Recipe Lookup: " + LogHelper.getStackDescription((IIngredient)this.stack);
    }
}
